-- (c) Xavier Ferrair Peir, aka Mortimer of Outland EU - Horde
-- no code in this file may be used in other works without expressed permission

local gsub = gsub

local function show_url(url)
	url = "|cff2E64FE|Hurl:"..url.."|h"..url.."|h|r"
	return url
end

local if_url = function(self, event, msg, ...)
	-- http...
	remsg, fmsg = gsub(msg, "(%a+)://(%S+)%s?", show_url("%1://%2"))
	if fmsg > 0 then
		return false, remsg, ...
	end
	-- www...
	remsg, fmsg = gsub(msg, "www%.([_A-Za-z0-9-]+)%.(%S+)%s?", show_url("www.%1.%2"))
	if fmsg > 0 then
		return false, remsg, ...
	end
	-- name.server.ts3:port
	remsg, fmsg = gsub(msg, "([_A-Za-z0-9-%.]+)%.([_A-Za-z0-9-%.]+)%.([_A-Za-z0-9-%.]+)%:([_A-Za-z0-9-%.]+)%s?", show_url("%1.%2.%3:%4"))
	if fmsg > 0 then
		return false, remsg, ...
	end
	-- email
	remsg, fmsg = gsub(msg, "([_A-Za-z0-9-%.]+)@([_A-Za-z0-9-]+)(%.+)([_A-Za-z0-9-%.]+)%s?", show_url("%1@%2%3%4"))
	if fmsg > 0 then
		return false, remsg, ...
	end
	-- ip
	remsg, fmsg = gsub(msg, "(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%s?", show_url("%1.%2.%3.%4"))
	if fmsg > 0 then
		return false, remsg, ...
	end
	-- ip:port
	remsg, fmsg = gsub(msg, "(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%.(%d%d?%d?)%:(%d%d?%d?%d?%d?)%s?", show_url("%1.%2.%3.%4:%5"))
	if fmsg > 0 then
		return false, remsg, ...
	end
	-- battleTag
	remsg, fmsg = gsub(msg, "([_A-Za-z0-9-%.]+)#(%d%d%d%d)%s?", show_url("%1#%2"))
	if fmsg > 0 then
		return false, remsg, ...
	end
end

ChatFrame_AddMessageEventFilter("CHAT_MSG_CHANNEL", if_url)
ChatFrame_AddMessageEventFilter("CHAT_MSG_SAY", if_url)
ChatFrame_AddMessageEventFilter("CHAT_MSG_YELL", if_url)
ChatFrame_AddMessageEventFilter("CHAT_MSG_GUILD", if_url)
ChatFrame_AddMessageEventFilter("CHAT_MSG_OFFICER", if_url)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY_LEADER", if_url)
ChatFrame_AddMessageEventFilter("CHAT_MSG_PARTY", if_url)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID_LEADER", if_url)
ChatFrame_AddMessageEventFilter("CHAT_MSG_RAID", if_url)
ChatFrame_AddMessageEventFilter("CHAT_MSG_WHISPER", if_url)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_WHISPER", if_url)
ChatFrame_AddMessageEventFilter("CHAT_MSG_BN_CONVERSATION", if_url)

local cLink = nil
local ChatFrame_OnHyperlinkShow_Original = ChatFrame_OnHyperlinkShow
ChatFrame_OnHyperlinkShow = function(self, link, ...)
	if (link):sub(1, 3) == "url" then
		cLink = (link):sub(5)
		StaticPopup_Show("BangUrlPopup")
		return
	end
	ChatFrame_OnHyperlinkShow_Original(self, link, ...)
end

StaticPopupDialogs["BangUrlPopup"] = {
	text = "BANG!",
	hasEditBox = 1,
	editBoxWidth = 333,
	button1 = CLOSE,
	EditBoxOnEscapePressed = function(frame)
		frame:GetParent():Hide()
	end,
	whileDead = 1,
	hideOnEscape = 1,
	preferredIndex = 3,
	timeout = 0,
	OnShow = function(frame)
		frame.editBox:HighlightText(0)
		frame.editBox:SetText(cLink)
		frame.editBox:SetFocus()
		cLink = nil
	end,
}